package test;

import java.io.*;
import java.lang.reflect.*;
import java.net.*;
import java.util.*;
import java.util.jar.*;
import java.util.zip.*;

public class JarTest {

  public static void main(String[] args) {
    if ( args.length < 1 )
      {
        System.out.println("kaffe test.JarTest jarfile.jar");
      }
    try
      {
        File f = new File(args[0]);
        JarFile j = new JarFile(f);
        Manifest m = j.getManifest();
        Enumeration e = j.entries();
        System.out.println("Is Manifest file null? " + (m==null));
        if (m!=null)
          {
            System.out.println("Manifest file:");
            m.write(System.out);
          }
        while(e.hasMoreElements())
          {
            JarEntry je = (JarEntry)e.nextElement();
            System.out.println("Jar entry: " + je.getName() );
          }
        URL[] urls = { new URL("file:" + args[0]) };
        URLClassLoader cl = new URLClassLoader (urls, ClassLoader.getSystemClassLoader());
        Class mainClass = cl.loadClass (args[1]);
        Class[] arguments = { String[].class };
        Method me = mainClass.getDeclaredMethod ("main", arguments);
        Object[] aa = { args };
        me.invoke ( mainClass, aa );
      }
    catch(Exception e)
      {
        e.printStackTrace();
      }
  }

}

